function [w,o] = pointmappostprune( w, o, delta, theta)
% PointMap post-training pruning (c) Norbert Kopco 2002
%
% Parameters:
% w,o, delta: code generated by PointMap training
% theta: per cent of nodes to be kept by the post-training pruning (0<=theta<=1). theta=1 means all nodes are kept
%
% Returns:
% variables w, o contain the subset of the learned code after post-training pruning

if theta<0 | theta>1       disp('Error: theta must be from range [0,1]!!!!');    w=[]; return; end

C=size(w,1);
% step 8
L=theta*C;
while C>L
    [aux, K]= min(delta);
    w = w([1:K-1 K+1:end],:);             o = o([1:K-1 K+1:end]); 
    delta = delta([1:K-1 K+1:end]);       C=C-1;
end
