function O = pointmaptest( w, o, Iv, k)
% PointMap testing (c) Norbert Kopco 2002
%
% Parameters:
% w,o: code generated by PointMap training (and post-training pruning)
% Iv: matrix of testing inputs (one input per row)
% k: number of nearest neighbors considered during testing
%
% Returns:
% variables w, o contain the subset of the learned code after post-training pruning

if size(w,1)~=size(o,1)    disp('Error: w and o must have the sume number of rows!!!!');    w=[]; return; end
if size(w,2)~=size(Iv,2)   disp('Error: w and I must have the sume number of columns!!!!');    w=[]; return; end
if k<1 | round(k)~=k       disp('Error: k must be an integer larger than 0!!!!');    w=[]; return; end
if min(o)<1                disp('o is assumed to include only integers larger than 0!!!!');    w=[]; return; end

N=size(Iv,1);
O=nan*ones(N,1);
C=size(w,1);
for m=1:N
    I=Iv(m,:);
    
    dist=sum(abs(repmat(I,C,1)-w),2);
    vote=zeros(max(o),1);
    for kind=1:min(k,C)
        [aux,lambda]=min(dist); dist(lambda)=inf; vote(o(lambda))=vote(o(lambda))+1;
    end
    [aux, O(m)]=max(vote);
end
